#include <bits/stdc++.h>

using namespace std;

#define DIM 100007
#define INF 1000000007

typedef long long ll;

string s1, s2, s3;
ll d[DIM];
ll n, m, a, k;

int main()
{
    cin >> n >> k;
    for(int i=1; i<=k; i++)
        cin >> m >> a;
    cout << "NO" <<endl;
    return 0;
}
/*

*/
